package org.xbib.interlibrary.action.sru;

import java.util.logging.Level;
import java.util.logging.Logger;
import org.xbib.interlibrary.api.action.ServiceArguments;

public abstract class AbstractSearchRetrieveService<Req extends SearchRetrieveRequest, Resp extends SearchRetrieveResponse, Serv extends SearchRetrieveService>
        implements SearchRetrieveService {

    private static final Logger logger = Logger.getLogger(AbstractSearchRetrieveService.class.getName());

    protected ServiceArguments arguments;

    private boolean enabled;

    private Throwable lastException;

    public AbstractSearchRetrieveService(ServiceArguments arguments) {
        this.arguments = arguments;
        this.enabled = arguments.getServiceSettingsAsBoolean("enabled", true);
    }

    @Override
    public void setEnabled(boolean enabled) {
        this.enabled = enabled;
    }

    @Override
    public boolean isEnabled() {
        return this.enabled;
    }

    @Override
    public void addThrowable(Throwable throwable) {
        logger.log(Level.SEVERE, throwable.getMessage(), throwable);
        this.lastException = throwable;
    }

    @Override
    public Throwable getLastThrowable() {
        return lastException;
    }
}
