package org.xbib.interlibrary.action.sru;

import java.util.Collections;
import java.util.List;
import org.xbib.interlibrary.api.action.Response;
import org.xbib.interlibrary.api.action.ResponseBuilder;

public class SearchRetrieveResponseBuilder implements ResponseBuilder<SearchRetrieveRequest, SearchRetrieveResponse> {

    protected SearchRetrieveRequest request;

    protected String service;

    protected Response.Status status;

    protected Throwable throwable;

    protected Long total;

    protected List<Record> records;

    protected List<Facet> facets;

    SearchRetrieveResponseBuilder() {
        this.status = Response.Status.UNDEFINED;
        this.request = null;
        this.total = -1L;
        this.records = Collections.emptyList();
        this.facets = Collections.emptyList();
    }

    @Override
    public SearchRetrieveResponseBuilder setRequest(SearchRetrieveRequest request) {
        this.request = request;
        return this;
    }

    @Override
    public SearchRetrieveResponseBuilder setStatus(String key, Response.Status status) {
        this.status = status;
        return this;
    }

    @Override
    public Response.Status getStatus() {
        return status;
    }

    @Override
    public SearchRetrieveResponseBuilder setThrowable(Throwable throwable) {
        this.throwable = throwable;
        return this;
    }

    @Override
    public Throwable getThrowable() {
        return throwable;
    }

    @Override
    public SearchRetrieveResponseBuilder setThrowable(String key, String message, Throwable throwable) {
        this.throwable = throwable;
        return this;
    }

    public SearchRetrieveResponseBuilder setService(String service) {
        this.service = service;
        return this;
    }

    public void setRecords(List<Record> records) {
        this.records = records;
    }

    public void setFacets(List<Facet> facets) {
        this.facets = facets;
    }

    public void setTotal(Long total) {
        this.total = total;
    }

    @Override
    public SearchRetrieveResponse build() {
        return new SearchRetrieveResponse(request, this);
    }
}
